!
!# Save scale factors for the ventricular wall elements
!
fem define base;r;fullheart_readse       !redefine bases to read in scale factors 
fem def line;w;fullheart_refmu reg 1     !write out scale factors for wall elements
fem define base;r;fullheart              !redefine bases to calculate scale factors
!
!
!# Define geometry and dependent variable information for LV and RV cavities
!
fem define region;r;coupled 
fem define coord;r;lvcavity_refmu reg 2
fem define node;r reg 2
fem define coord;r;rvcavity_refmu reg 3
fem define node;r reg 3
fem define element;r;lvcavity_refmu reg 2
fem define element;r;rvcavity_refmu reg 3
fem group elem 121..180 as lv_cavity_elems reg 2
fem group elem 151..160 as lv_cavity_base_elems reg 2
fem group nodes xi2=1 xi3=1 elem lv_cavity_base_elems as lv_cavity_base_nodes reg 2
fem group elem 181..198 as rv_cavity_elems reg 3
fem define equation;r;coupled reg 1,2,3 lock
fem define material;r;cavity reg 2
fem define material;r;cavity reg 3
fem define initial;r;lvcavity_refmu reg 2
fem define initial;r;rvcavity_refmu reg 3
!
!
!# Define cavity/wall coupling and solution information
!
fem define coup;r;coupled
fem define solve;r;coupled coupled reg 1,2,3
fem update solution coupled source_region 1
fem update solution cavity_reference average 196 in 1 node lv_cavity_base_nodes region 2
fem update solution cavity_reference average 203 in 1 node 14,18 region 3
!
!
!# Read back in scale factors for the ventricular wall elements
!
fem define base;r;fullheart_readse       !redefine bases to read in scale factors 
fem def line;r;fullheart_refmu reg 1     !read in scale factors for wall elements
fem define base;r;fullheart              !redefine bases to calculate scale factors
!
!#
!# EITHER: solve all coupled phases
!#
!read com;solve_coupled_contract_refmu_pericard
!read com;solve_coupled_eject_refmu_pericard
!read com;solve_coupled_isovolrelax_refmu_pericard
!#
!# OR: read in state at end of isovol contraction and then solve
!#
!fem define active;r;active0_24 reg 1
!fem define initial;r;fullheart_def_0010_active_0024 reg 1,2,3
!fem define solve;r;coupled coupled reg 1,2,3 
!read com;solve_coupled_eject_refmu_pericard
!read com;solve_coupled_isovolrelax_refmu_pericard
!#
!# OR: read in state at end of ejection and then solve
!#
!fem define material;r;cavity_00000100 reg 2
!fem define material;r;cavity_00000100 reg 3
!fem define active;r;active0_24 reg 1
!fem define initial;r;fullheart_def_0010_active_0024_cavk_00000100 reg 1,2,3
!fem define solve;r;coupled coupled reg 1,2,3 
!read com;solve_coupled_isovolrelax_refmu_pericard
